import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.awt.Font;
import java.awt.Color;

import java.util.Timer;
import java.util.TimerTask;

/**
 * Write a description of class Selector here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Selector  extends Actor
{
    GreenfootImage selector = new GreenfootImage("SelectorPanel.gif");
    boolean initialized = false;
    boolean btndwn = false;
    boolean upbtnpshd = false;
    boolean dnbtnpshd = false;
    Upbtn ubtn = new Upbtn();
    Dnbtn dbtn = new Dnbtn();
    int num = 0;
    int min = 0; // the minimum the selsector can go
    int max = 130; // the maximum the selector can go
    int inc = 1; // the amount the selector increments per click
    int labelnum = 1;
    PianoWorld world;
    int incrementor = 0;
    int okgo = 3;
    
    boolean autoincrementing = false;
    boolean incrementedyet = false;
    boolean autodecrementing = false;
    boolean decrementedyet = false;
    Timer t = new Timer();
    Increment I = new Increment(); // this class increments the timer 
    
    public Selector() {
        setImage(selector);
    }
    /**
     * Act - do whatever the Selector wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act() 
    {
        // Add your action code here.
        if (!initialized) {
            initialize();
            initialized = true;
        }
        
        checkButtons();
        drawNum();
    }
    
    public int returnNum()
    {
        return num;
    }
    
    public void checkButtons()
    {
        if (!btndwn) {
            if (ubtn.gotPushed()) {
                btndwn = true; upbtnpshd = true;
                num += inc;
                if (num < min) num = max;
                if (num > max) num = min;
                doThing();
            }
            if (dbtn.gotPushed()) {
                btndwn = true; dnbtnpshd = true;
                num -= inc;
                if (num < min) num = max;
                if (num > max) num = min;
                doThing();
            }
        }
        if (btndwn) {
            if (upbtnpshd) {
                if (ubtn.gotReleased()) {
                    upbtnpshd = false; btndwn = false;
                }
            }
            if (dnbtnpshd) {
                if (dbtn.gotReleased()) {
                    dnbtnpshd = false; btndwn = false;
                }
            }            
        }
        
        // ok, that was complicated.  My logic..is just patched together.  I'm not going
        // to go back and mess with any of that.  BUT NOW I want to check if the button was
        // held down.  This isn't hard.
        if (ubtn.wasHeldForAWhile()) {
            if (!autoincrementing) {
                autoincrementing = true; /// ok so now we begin autoincrementing
            }
            if (autoincrementing) {
                if (!incrementedyet) {
                    //t is the timer object
                    t.schedule(new Increment(),33); // do this every 33 milliseconds
                    incrementedyet = true; // gets set to false when actually incremented
                }
            }
        } else {
            autoincrementing = false;
        }
        
        if (dbtn.wasHeldForAWhile()) {
            if (!autodecrementing) {
                autodecrementing = true; /// ok so now we begin autoincrementing
            }
            if (autodecrementing) {
                if (!decrementedyet) {
                    //t is the timer object
                    t.schedule(new Decrement(),33); // do this every 33 milliseconds
                    decrementedyet = true; // gets set to false when actually incremented
                }
            }
        } else {
            autodecrementing = false;
        }
            // ok just use an int which keeps track...
        //    incrementor ++;
        //   if (incrementor >= okgo) {
        //        doThing();
         //       num--;
         //       if (num < min) num = max;
          //      if (num > max) num = min;
         //       incrementor = 0;
          //  }
        
    }
    
    public class Increment extends TimerTask{
        public void run() {
            doThing();
            num++;
            if (num < min) num = max;
            if (num > max) num = min;
            incrementedyet = false;
        }
    }
    
    public class Decrement extends TimerTask {
        public void run() {
            doThing();
            num--;
            if (num < min) num = max;
            if (num > max) num = min;
            decrementedyet = false;
        }
    }
    
    public void doThing()
    {
    }
    
    public void drawNum() {
        GreenfootImage n = new GreenfootImage(selector.getWidth(),selector.getHeight());
        n.drawImage(selector,0,0);
        Font font = n.getFont();
        font = font.deriveFont(40.0F);
        n.setFont(font);
        n.setColor(Color.GREEN);
        n.drawString("" + num,35,70);
        setImage(n);
    }
    
    
    
    public void initialize() {
        getWorld().addObject(ubtn,getX()+56,getY()-23);
        getWorld().addObject(dbtn,getX()+56,getY()+23);
        getWorld().addObject(new Label(labelnum),getX()-23,getY()-30);
        world = (PianoWorld) getWorld();
    }
}
